#ifndef LW_FFTW3_H
# define LW_FFTW3_H

# include "fftw3.h"
# include "lastwave.h"
# include "signals.h"


extern void C_Lwfftw_convol(char **argv);
extern void C_Fftw(char **argv);
extern void DeclareFftw3Package(void);

# define LW_FFTW_CONCAT(root,name) root ## name 

# if defined(NUMDOUBLE) /* LastWave FLOATS are double */
#  define LW_FFTW_NAMES(name) LW_FFTW_CONCAT(fftw_,name)
# elif defined(NUMFLOAT) /* LastWave FLOATS are float */
#  define LW_FFTW_NAMES(name) LW_FFTW_CONCAT(fftwf_,name)
# else
#  error Neither NUMDOUBLE nor NUMFLOAT is defined !
# endif


typedef LW_FFTW_NAMES(complex) lw_fftw_complex;
typedef LW_FFTW_NAMES(plan) lw_fftw_plan;

/* FOR compatibility with LW_2_1 */
# if !defined(LWFLOAT)
#  define LWFLOAT FLOAT
# endif

/* Multithreading */
# if !defined(LW_FFTW_NO_THREAD)
extern int lwfftw_multhr_nthreads;
# endif

#endif
