/*..........................................................................*/
/*                                                                          */
/*      Pollux 2.1                                                          */
/*                                                                          */
/*      Authors: Benjamin Audit, Emmanuel Bacry and Cedric Vaillant         */
/*      Copyright (C) 1997-2005.  All Right Reserved.                       */
/*                                                                          */
/*      Contact: Benjamin.Audit@ens-lyon.fr                                 */
/*                                                                          */
/*..........................................................................*/
/*                                                                          */
/*      This program is a free software, you can redistribute it and/or     */
/*      modify it under the terms of the GNU General Public License as      */
/*      published by the Free Software Foundation; either version 2 of the  */
/*      License, or (at your option) any later version                      */
/*                                                                          */
/*      This program is distributed in the hope that it will be useful,     */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of      */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       */
/*      GNU General Public License for more details.                        */
/*                                                                          */
/*      You should have received a copy of the GNU General Public License   */
/*      along with this program (in a file named COPYRIGHT);                */
/*      if not, write to the Free Software Foundation, Inc.,                */
/*      59 Temple Place, Suite 330, Boston, MA  02111-1307  USA             */
/*                                                                          */
/*..........................................................................*/

#ifndef HELIX_3D_H
#define HELIX_3D_H

#include <stdio.h>
#include <math.h>
#include <string.h>

#ifndef NOT_USED_WITH_LW
#include "double.h"
#else
#define FLOAT float
#endif /* NOT_USED_WITH_LW */


extern char index_2_nuc(int i);
extern int nuc_2_index(char nuc);

extern int compute_all_angle(char *seq,FLOAT *Y,int size,int size_window);
extern int compute_all(char *seq,FLOAT *X,FLOAT *Y,FLOAT *Z,int size);
extern int change_tilt_file(const char *filename);
extern int change_roll_file(const char *filename);
extern int compute_courb_table(FLOAT tab[4][4][4]);

#endif /* HELIX_3D_H */
