/*..........................................................................*/
/*                                                                          */
/*      Long String 0.1                                                     */
/*                                                                          */
/*      Authors: Benjamin Audit.                                            */
/*      Copyright (C) 2005.  All Right Reserved.                            */
/*                                                                          */
/*      Contact: Benjamin.Audit@ens-lyon.fr                                 */
/*                                                                          */
/*..........................................................................*/
/*                                                                          */
/*      This program is a free software, you can redistribute it and/or     */
/*      modify it under the terms of the GNU General Public License as      */
/*      published by the Free Software Foundation; either version 2 of the  */
/*      License, or (at your option) any later version                      */
/*                                                                          */
/*      This program is distributed in the hope that it will be useful,     */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of      */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       */
/*      GNU General Public License for more details.                        */
/*                                                                          */
/*      You should have received a copy of the GNU General Public License   */
/*      along with this program (in a file named COPYRIGHT);                */
/*      if not, write to the Free Software Foundation, Inc.,                */
/*      59 Temple Place, Suite 330, Boston, MA  02111-1307  USA             */
/*                                                                          */
/*..........................................................................*/

#ifndef LONGSTRING_H
#define LONGSTRING_H

/* TYPE LongString*/
typedef struct LongString  *LONGSTRING;

extern LONGSTRING LSNew(void);
extern void LSDelete(LONGSTRING ls);
extern void LSFreeSpace(LONGSTRING ls);
extern void LSSetStringEmpty(LONGSTRING ls);

/****************************************************************************/
/* CONCATENATES A CHAR * AT THE END OF A LONGSTRING                         */
/****************************************************************************/
extern LONGSTRING LSConcatLine(LONGSTRING ls, char *line);

/****************************************************************************/
/* Get Fonctions                                                            */
/****************************************************************************/
/* returns the C string */
/* YOU SHOULD NOT MODIFY it in any way */
extern char *LSGetString(LONGSTRING ls);
/* returns the length of the string */
extern size_t LSStringLength(LONGSTRING ls);


#endif /* LONGSTRING_H */
