/*..........................................................................*/
/*                                                                          */
/*      Pollux 1.7                                                          */
/*                                                                          */
/*      Authors: Benjamin Audit, Emmanuel Bacry and Cedric Vaillant         */
/*      Copyright (C) 1997-2002.  All Right Reserved.                       */
/*                                                                          */
/*      Contact: audit@ebi.ac.uk                                            */
/*                                                                          */
/*..........................................................................*/
/*                                                                          */
/*      This program is a free software, you can redistribute it and/or     */
/*      modify it under the terms of the GNU General Public License as      */
/*      published by the Free Software Foundation; either version 2 of the  */
/*      License, or (at your option) any later version                      */
/*                                                                          */
/*      This program is distributed in the hope that it will be useful,     */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of      */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       */
/*      GNU General Public License for more details.                        */
/*                                                                          */
/*      You should have received a copy of the GNU General Public License   */
/*      along with this program (in a file named COPYRIGHT);                */
/*      if not, write to the Free Software Foundation, Inc.,                */
/*      59 Temple Place, Suite 330, Boston, MA  02111-1307  USA             */
/*                                                                          */
/*..........................................................................*/

#include "pollux.h"
#include "lastwave.h"

static char random_nuc(FLOAT a,FLOAT t,FLOAT g)
{
  FLOAT p = Urand();

  if(p<a) {return 'a';}
  if(p<t) {return 't';}
  if(p<g) {return 'g';}
  return 'c';
}

int ran_seq(PolluxBuffer *seqBuffer,int size,FLOAT a,FLOAT t,FLOAT g)
{
  int i;
  
  /* SOME CONSISTENCY CHECKING */
  if(size >= POLBUFFERSIZE || size < 1 || a+t+g>1.)
    return -1;
  
  /* INITIALISATION  */
  seqBuffer->buffer[0] = '\0'; 
  seqBuffer->size = 0;

  /* TRANSFORMING PROBA IN THRESHOLD */
  t += a;
  g += t;
  for(i=0;i<size;i++)
    {
      seqBuffer->buffer[i] = random_nuc(a,t,g);
    }
  seqBuffer->buffer[size] = '\0';
  seqBuffer->size = size;

  return 0;
}
