#include "lastwave.h"
#include "signals.h"

static void SpConvolPer(SIGNAL in, int nWavelet)
{
  int i,size = in->size;
  FLOAT norm;
  SIGNAL out = TNewSignal();

  SizeSignal(out,in->size,YSIG);
  if (in->type == YSIG) {
    out->dx = in->dx;
    out->x0 = in->x0;
  }

  switch (nWavelet) {
  case 0:
    for(i=0;i<size;i++){
      out->Y[i]= in->Y[i];
    }
    break;
    
  case 1:
    norm = 1./sqrt(2.);
    for(i=0;i<size-1;i++){
      out->Y[i] = (in->Y[i+1]-in->Y[i])*norm;
    }
    out->Y[size-1] = (in->Y[0]-in->Y[size-1])*norm;;
    break;


  case 2:
    norm = 1./sqrt(6.0);
    for(i=1;i<size-1;i++){
      out->Y[i]= ( 2*in->Y[i]-(in->Y[i-1]+in->Y[i+1]) )*norm;
    }
      out->Y[0] = ( 2*in->Y[0]-(in->Y[size-1]+in->Y[1]) )*norm;
      out->Y[size-1] = ( 2*in->Y[size-1]-(in->Y[size-2]+in->Y[0]) )*norm;
    break;
  
  case 3:
    norm = 1.0/sqrt(20);
    for(i=1;i<size-2;i++){
      out->Y[i]= (3*(in->Y[i]-in->Y[i+1])+(in->Y[i+2]-in->Y[i-1]))*norm;
    }
    out->Y[0]= (3*(in->Y[0]-in->Y[1])+(in->Y[2]-in->Y[size-1]))*norm;
    out->Y[size-2]= (3*(in->Y[size-2]-in->Y[size-1])+(in->Y[0]-in->Y[size-3]))*norm;
    out->Y[size-1]= (3*(in->Y[size-1]-in->Y[0])+(in->Y[1]-in->Y[size-2]))*norm;
    break;
    
  default :
    Errorf("SpConvolPer() : Unknown wavelet number '%d'",nWavelet);  

  }

  SetResultValue(out);
}

void C_SpConvolPer(char **argv)
{
  SIGNAL in;
  int nWavelet;

  argv = ParseArgv(argv,tSIGNALI,&in,tINT,&nWavelet,0);

  SpConvolPer(in,nWavelet);
}

static CProc benMiscCommands[] = {

  "spconvolper",C_SpConvolPer,
  "{{{<sig_in> <nWave>} {Return the increments of order nWave computed with periodic border effect.}}}",

  NULL,NULL,NULL
};

CProcTable benMiscTable = 
{benMiscCommands, "benMisc",
 "Benjamin miscellaneous commands."};

