

#include "lastwave.h"



/*
 * This is the C-function that is called at initialization of LastWave
 * You should declare your packages here
 */


void UserInit(void) 
{ 
  extern void DeclareSignalPackage(void);
  extern void DeclareImagePackage(void);
  /* extern void DeclareMRWPackage(void);  */
  extern void DeclareSoundPackage(void);
  extern void DeclareWtrans1dPackage(void);
  extern void DeclareExtrema1dPackage(void);
  extern void DeclareWtmm1dPackage(void);
  extern void DeclareOWtrans2dPackage(void);
  extern void DeclareCompress2dPackage(void);
  extern void DeclareDWtrans2dPackage(void);
  extern void DeclareStftPackage(void);
  extern void DeclareMpPackage(void);

  extern void DeclareFftw3Package(void);

  extern CProcTable polluxTable;
  extern CProcTable gregTable;
  extern CProcTable benMiscTable;
  extern CProcTable fitTable;
  extern CProcTable spTable;
  extern CProcTable histo2VTable;

  /* Tables in vanderlick.c */
  extern CProcTable vanderlickTable;
  extern CProcTable utilTable;

  AddCProcTable(&polluxTable);
  AddCProcTable(&gregTable);
  AddCProcTable(&benMiscTable);
  AddCProcTable(&spTable);
  AddCProcTable(&histo2VTable);

  AddCProcTable(&vanderlickTable);
  AddCProcTable(&utilTable);

  DeclareSignalPackage();

  DeclareImagePackage();
  
  DeclareSoundPackage();
  
  DeclareWtrans1dPackage();
  DeclareExtrema1dPackage();
  
  DeclareStftPackage();
  DeclareMpPackage();
  
  DeclareWtmm1dPackage();
  
  DeclareOWtrans2dPackage();
  DeclareCompress2dPackage();

  DeclareDWtrans2dPackage();

  DeclareFftw3Package();
} 

 
 
